
Redmine - Defect #21855

Gravatar get images over http instead https

2016-01-26 23:05 - Alexander Kupchenko

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 3.3.0   

Resolution: Fixed Affected version: 3.2.0

Description

Hello!

Our redmine works via https, in preferences https is set up. But gravatars still use http-image links.

Details in attached picture.

Your prompt reply will be highly appreciated!

Related issues:

Related to Redmine - Patch #18911: check Setting.protocol when determining gr... Closed

Related to Redmine - Defect #9365: Gravatar don't utilize HTTPS Closed 2011-10-03

Associated revisions

Revision 15245 - 2016-03-15 22:52 - Jean-Philippe Lang

Use protocol-relative URL for gravatars (#21855).

Patch by Go MAEDA.

History

#1 - 2016-01-27 01:22 - Jérôme BATAILLE

It's because the detection of https is made with request.ssl? which does not work with https managed by front proxies.

A fix in app/helpers/application_helper.rb :

  def avatar(user, options = { })

    if Setting.gravatar_enabled?

      # The fix : checking if https is enabled in configuration

      options.merge!({:ssl => (Setting.protocol == 'https'), :default => Setting.gravatar_default})

      # options.merge!({:ssl => (request && request.ssl?), :default => Setting.gravatar_default})

      email = nil

      if user.respond_to?(:mail)

        email = user.mail

      elsif user.to_s =~ %r{<(.+?)>}

        email = $1

      end

      return gravatar(email.to_s.downcase, options) unless email.blank? rescue nil

    else

      ''

    end

  end

#2 - 2016-01-28 16:59 - Go MAEDA

- File gravatar-protocol-relative-url.diff added

Using protocol relative URL (begins with two slash characters, e.g. //www.gravatar.com/avatar/... ) will resolve this issue. Please take a look at this

patch: gravatar-protocol-relative-url.diff

Redmine don't have to know whether it is accessed via HTTPS or HTTP because web browsers choose appropriate protocol to access Gravatar.
#3 - 2016-02-08 13:57 - Go MAEDA

- Related to Patch #18911: check Setting.protocol when determining gravatar protocol added

#4 - 2016-02-08 13:58 - Go MAEDA

- Related to Defect #9365: Gravatar don't utilize HTTPS added

#5 - 2016-02-08 13:59 - Go MAEDA

- Target version set to 3.3.0

#6 - 2016-03-10 01:04 - Ken Zalewski

I am confirming this issue when running Redmine 3.2.0 with Passenger 5.0.22.

The protocol setting (Settings->General->Protocol) is ignored, because the logic in application_helper.rb is flawed.

The suggested patch in Note 1 above seems to work fine.

#7 - 2016-03-15 22:53 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Jérôme BATAILLE wrote:

It's because the detection of https is made with request.ssl? which does not work with https managed by front proxies.

A fix in app/helpers/application_helper.rb :

[...]

 The same "fix" was applied in r10184 and reverted soon after, see #9365 for more details.

I've committed the solution proposed by Go Maeda in r15245. Thanks.

#8 - 2016-03-18 14:00 - Ken Zalewski

I see that this issue has been closed, but I want to mention that this problem persists into version 3.2.1.  Apparently, the patch did not make it in to

3.2.1, which is unfortunate.

I will hand-edit the files for now, and anticipate the 3.2.2 release.

#9 - 2016-03-18 14:07 - Ken Zalewski

I am confirming that the Go Maeda patch in r15245 resolves the issue.

#10 - 2016-03-18 14:11 - Ken Zalewski

I need to take that back.  I am now getting a full SSL connection, which is great.  However, after applying that patch, Gravatars are no longer being

displayed at all.

Is there something else I need to do?

#11 - 2016-03-18 14:19 - Ken Zalewski

After clearing my browser's cache, all is fine!  Gravatars are being properly displayed within a full SSL environment.  There are no non-SSL

components, so the site is considered fully secured.

Thank you.

#12 - 2016-03-19 09:02 - Jean-Philippe Lang

Ken Zalewski wrote:

I see that this issue has been closed, but I want to mention that this problem persists into version 3.2.1.  Apparently, the patch did not make it in

to 3.2.1, which is unfortunate.

I will hand-edit the files for now, and anticipate the 3.2.2 release.

 As you can see, this issue is assigned to 3.3.0, and the fix was not included in 3.2.1
#13 - 2016-03-21 12:06 - Ken Zalewski

Yes, I do see that now.  I missed that when I was testing the 3.2.1 release.

I will anticipate the 3.3.0 release then.  :-)

#14 - 2016-08-26 12:28 - Helge Sychla

We are on version 3.3.0.stable.15633 and the avatars are still pulled using HTTP.

I checked the code and the changes from r15245 are in there.

We are using a couple of plugins from redminecrm.com, could they be doing something that reverts this patch?

#15 - 2017-01-09 12:36 - Helge Sychla

Just in case somebody else is having this problem and gets here via Google:

We were missing

proxy_set_header X-Forwarded-Proto $scheme;

 in our nginx config so redmine was not aware that the original request was HTTPS.

Added that and now the whole page is HTTPS again.

Files

gravatar.jpg 204 KB 2016-01-26 Alexander Kupchenko

gravatar-protocol-relative-url.diff 1.92 KB 2016-01-28 Go MAEDA
